#----------------------------------------------------------------------------
# Ytube 		-    Youtube.com
# :	.chanset #chan +ytube
# :		!ytube [-] [-rate|-fav|-view|-pop|-comm] <>
# *     - -     ,
#     -  $maxres    
#   : -rate -  , -fav -  , -view -  , -pop -  , -comm -  		
# :		
# :		anaesthesia #eggdrop@Rusnet
# :		http://egghelp.ru
#----------------------------------------------------------------------------
# v.2 -    Youtube API

package require Tcl 	8.4
package require http	2.5

namespace eval ytube {
foreach p [array names ytube *] {catch {unset ytube ($p)}}

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    , ,   
	variable author			"anaesthesia"
	variable version		"02.00"
	variable date			"02-Aug-2008"
	variable unamespace		[namespace tail [namespace current]]

	#     (   )
	variable pubprefix 		{!}
	variable pubflag		{-|-}

	#   ()
	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:ytube		"$unamespace"

	#    ,   
	variable msgprefix		{!}
	variable msgflag		{-|-}

	#       
	variable msg:ytube		${pub:ytube}

	#*      ,      
	#*     variable [pub|msg]:handler "string ..."

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id   .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	1

	#     
	variable maxrequests	5

	#   ,       ,  
	variable pause			15
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		""
	
	#   ,   /   
	#          
	#        
	#      

	variable chflag			"$flagactas$unamespace"
	setudef  flag 			$chflag

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	{'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
	
	#     ,   --  
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   --  
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :}

	#      
	variable maxredir		3
	
	#    ,   30 
	variable timeout		30000

	#    
	variable err_ok			{  .}

	#     ,     
	#       
	variable err_fail		{     .      -.}

	#     
	variable err_queue_full	{           .   .}
	
	#       id
	variable err_queue_id	{    .}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time {   .       $timewait .}
	
#----------------------------------------------------------------------------
#     
#----------------------------------------------------------------------------
	#   
	variable maxres		3

	#  
	variable 		reqqueue
	array unset 	reqqueue

	#  
	variable 		laststamp
	array unset		laststamp 
	variable		updinprogress	0
	variable		updatetimeout	60000

#---body---

	proc msg:ytube {unick uhost handle str} {
		pub:ytube $unick $uhost $handle $unick $str
		return
	}

	proc pub:ytube {unick uhost handle uchan str} {

		variable requserid
		variable fetchurl
		variable chflag
		variable flagactas
		variable errsend	
		variable maxres
		variable pubprefix
		variable pubsend
		variable msgsend
		variable unamespace
		variable ytype
		variable mpage
		variable query
		variable logrequests

		set id [subst -noc $requserid]
		set prefix [subst -noc $errsend]

		if {$unick ne $uchan} {if {![channel get $uchan $chflag] ^ $flagactas eq "no" } {return}}

		set why [queue_isfreefor $id]
		if {$why != ""} {lput puthelp $why $prefix ; return}
		set query ""

#---
		set ustr [string trim $str]

		if {[regexp -nocase -- {^-(\d+)} $ustr -> mpage]} {regsub -- {-\d+\s+} $ustr "" ustr ; set ytype 1} {set mpage 1 ; set ytype 0}
 		if {[string match "*-rate*" $ustr]} {
			set fetchurl "http://gdata.youtube.com/feeds/api/standardfeeds/top_rated?start-index=$mpage&max-results=$maxres&racy=include" ; set ytype 2
		} elseif {[string match "*-fav*" $ustr]} {
			set fetchurl "http://gdata.youtube.com/feeds/api/standardfeeds/top_favorites?start-index=$mpage&max-results=$maxres&racy=include" ; set ytype 2
		} elseif {[string match "*-view*" $ustr]} {
			set fetchurl "http://gdata.youtube.com/feeds/api/standardfeeds/most_viewed?start-index=$mpage&max-results=$maxres&racy=include" ; set ytype 2
		} elseif {[string match "*-pop*" $ustr]} {
			set fetchurl "http://gdata.youtube.com/feeds/api/standardfeeds/most_popular?start-index=$mpage&max-results=$maxres&racy=include" ; set ytype 2
		} elseif {[string match "*-comm*" $ustr]} {
			set fetchurl "http://gdata.youtube.com/feeds/api/standardfeeds/most_discussed?start-index=$mpage&max-results=$maxres&racy=include" ; set ytype 2
		} else {
			set fetchurl "http://gdata.youtube.com/feeds/api/videos?vq=[uenc $ustr]&orderby=relevance&start-index=$mpage&max-results=$maxres&racy=include"
		}

		::http::config -useragent "Mozilla/5.0 (X11; U; Linux i686; ru-RU; rv:1.8.1) Gecko/2006101023 Firefox/2.0"

			if {[string is space $ustr]} {
				set prefix [subst -noc $msgsend]
				lput puthelp "\002\002: \002${pubprefix}${unamespace}\002 \[-\] \[-rate|-fav|-view|-pop|-comm\] <> ::    youtube.com" $prefix
				lput puthelp "\002:\002 \002-rate\002 -  , \002-fav\002 -  , \002-view\002 -  , \002-pop\002 -  , \002-comm\002 -  " $prefix		
				return
			}

		if {$logrequests ne ""} {set logstr [subst -noc $logrequests] ; lput putlog $logstr "$unamespace: "}
		if {[queue_add "${fetchurl}" $id "[namespace current]::ytube:parser" [list $unick $uhost $uchan $ustr]]} {
			variable err_ok ; if {$err_ok ne ""} {lput puthelp "$err_ok" $prefix}
		} {
			variable err_fail ; if {$err_fail ne ""} {lput puthelp "$err_fail" $prefix}
		}

	return
	}

#---parser
	proc ytube:parser {errid errstr body extra} {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra

		variable err_fail
		variable pubsend
		variable msgsend
		variable errsend
		variable maxres
		variable mpage
		variable ytype

		foreach {unick uhost uchan ustr} $lextra {break}
		if {$lerrid ne {ok}} {lput putserv [subst -noc $err_fail] [subst -noc $errsend] ; return}
		if {$uchan eq $unick} {set prefix [subst -noc $msgsend]} {set prefix [subst -noc $pubsend]}

		if {[info exists ::sp_version]} {set str [encoding convertfrom utf-8 $lbody]} {set str $lbody}

#----------------------------------------------------------------------------
##---parser-specific------
#----------------------------------------------------------------------------
	regsub -all -- "\n" $str "" str
	regsub -all -- "</entry>" $str "</entry>\n" str

	if {![regexp -- {^(.+?)<entry>} $str -> yhead]} {lput putserv "\037  \037." $prefix ; return}
	regexp -- {<openSearch:totalResults>(.+?)</openSearch:totalResults>} $yhead -> ytotal
	regexp -- {<title type='text'>(.+?)</title>} $yhead -> ytitle
	regsub -- {^(.+?)<entry>} $str "" str

	set res [list] ; set cnt 0
	foreach yd [split $str \n] {
		regexp -- {<published>(.+?)</published>} $yd -> ydate
		regexp -- {<title type='text'>(.+?)</title>} $yd -> ytshort
		regexp -- {<content type='text'>(.+?)</content>} $yd -> ytlong
		regexp -- {<link rel='alternate' type='text/html' href='(.+?)'/>} $yd -> ylink
		regexp -- {<media:keywords>(.+?)</media:keywords>} $yd -> ykeyw
		regexp -- {<yt:duration seconds='(.+?)'/>} $yd -> ydur
		regexp -- {<media:category.*?'>(.+?)</media:category>} $yd -> ycat
		if {![regexp -- {<yt:statistics viewCount='(.+?)' favoriteCount='(.+?)'/>} $yd -> yview yfav]} {set yview "-" ; set yfav "-"}
		if {![regexp -- {<gd:rating.*?numRaters='(.+?)' average='(.+?)'/>} $yd -> yraten yrate]} {set yraten  "-" ; set yrate "-"}

		if {$ytype == 1} {
			lappend res "\[$mpage/$ytotal\] :: \00305$ytshort\003 :: $ytlong :: \00314($ykeyw)\003 :: \[\002T\002:[clock format $ydur -format "%M:%S"]/\002R\002:${yrate}($yraten)/\002V\002:$yview/\002F\002:$yfav/\002A\002:[clock format [clock scan [string range $ydate 0 9]] -format %d-%m-%Y]/\002$ycat\002\] \@ \037\00312$ylink\003\037"
			lput putserv "[sconv [join $res]]" $prefix
			break
		} {
			incr cnt
			lappend res "$ytshort \@ \037\00312$ylink\003\037 | "  
			if {$cnt == $maxres} {break}
		}
	}
		if {$ytype == 0} {lput putserv "\[$ytotal\] :: [sconv [join $res]]" $prefix}
		if {$ytype == 2} {lput putserv "\002\[$ytitle\]\002 :: [sconv [join $res]]" $prefix}

	return
	}		
#----------------------------------------------------------------------------
##---end-parser------
#----------------------------------------------------------------------------

	proc sspace  {strr} {return [string trim [regsub -all {[\t\s]+} $strr { }]]}
	proc tolow   {strr} {return [string tolower [string map {                                                                 } $strr]]}

	proc uenc {strr} {
	set str ""
		foreach byte [split [encoding convertto utf-8 $strr] ""] {scan $byte %c i ; if {[string match {[%<>"]} $byte] || $i < 65 || $i > 122} {append str [format %%%02X $i]} {append str $byte}}
	return [string map {%3A : %2D - %2E . %30 0 %31 1 %32 2 %33 3 %34 4 %35 5 %36 6 %37 7 %38 8 %39 9 \[ %5B \\ %5C \] %5D \^ %5E \_ %5F \` %60} $str]
    }

	proc sconv {strr} {
	set escapes {
        &nbsp; \x20 &quot; \x22 &amp; \x26 &apos; \x27 &ndash; \x2D
        &lt; \x3C &gt; \x3E &tilde; \x7E &euro; \x80 &iexcl; \xA1
        &cent; \xA2 &pound; \xA3 &curren; \xA4 &yen; \xA5 &brvbar; \xA6
        &sect; \xA7 &uml; \xA8 &copy; \xA9 &ordf; \xAA &laquo; \xAB
        &not; \xAC &shy; \xAD &reg; \xAE &hibar; \xAF &deg; \xB0
        &plusmn; \xB1 &sup2; \xB2 &sup3; \xB3 &acute; \xB4 &micro; \xB5
        &para; \xB6 &middot; \xB7 &cedil; \xB8 &sup1; \xB9 &ordm; \xBA
        &raquo; \xBB &frac14; \xBC &frac12; \xBD &frac34; \xBE &iquest; \xBF
        &Agrave; \xC0 &Aacute; \xC1 &Acirc; \xC2 &Atilde; \xC3 &Auml; \xC4
        &Aring; \xC5 &AElig; \xC6 &Ccedil; \xC7 &Egrave; \xC8 &Eacute; \xC9
        &Ecirc; \xCA &Euml; \xCB &Igrave; \xCC &Iacute; \xCD &Icirc; \xCE
        &Iuml; \xCF &ETH; \xD0 &Ntilde; \xD1 &Ograve; \xD2 &Oacute; \xD3
        &Ocirc; \xD4 &Otilde; \xD5 &Ouml; \xD6 &times; \xD7 &Oslash; \xD8
        &Ugrave; \xD9 &Uacute; \xDA &Ucirc; \xDB &Uuml; \xDC &Yacute; \xDD
        &THORN; \xDE &szlig; \xDF &agrave; \xE0 &aacute; \xE1 &acirc; \xE2
        &atilde; \xE3 &auml; \xE4 &aring; \xE5 &aelig; \xE6 &ccedil; \xE7
        &egrave; \xE8 &eacute; \xE9 &ecirc; \xEA &euml; \xEB &igrave; \xEC
        &iacute; \xED &icirc; \xEE &iuml; \xEF &eth; \xF0 &ntilde; \xF1
        &ograve; \xF2 &oacute; \xF3 &ocirc; \xF4 &otilde; \xF5 &ouml; \xF6
        &divide; \xF7 &oslash; \xF8 &ugrave; \xF9 &uacute; \xFA &ucirc; \xFB
        &uuml; \xFC &yacute; \xFD &thorn; \xFE &yuml; \xFF
	}
	set strr [string map $escapes [join [lrange [split $strr] 0 end]]] 
    regsub -all -- {\[} $strr "\\\[" strr
    regsub -all -- {\]} $strr "\\\]" strr
    regsub -all -- {\(} $strr "\\\(" strr
    regsub -all -- {\)} $strr "\\\)" strr
  	regsub -all -- {&#([[:digit:]]{1,5});} $strr {[format %c [string trimleft "\1" "0"]]} strr
 	regsub -all -- {&#x([[:xdigit:]]{1,4});} $strr {[format %c [scan "\1" %x]]} strr
 	regsub -all -- {&#?[[:alnum:]]{2,7};} $strr "" strr
	return [subst -nov $strr]
	}

	proc lput {cmd str {prefix {}} {maxchunk 420}} {
	set buf1 "" ; set buf2 [list]
		foreach word [split $str] {append buf1 " " $word ; if {[string length $buf1]-1 >= $maxchunk} {lappend buf2 [string range $buf1 1 end] ; set buf1 ""}}
		if {$buf1 != ""} {lappend buf2 [string range $buf1 1 end]}
		foreach line $buf2 {$cmd $prefix$line}
	return
	}

	proc queue_isfreefor {{id {}}} {

		variable reqqueue
		variable maxreqperuser
		variable maxrequests
		variable laststamp
		variable pause
		variable err_queue_full	
		variable err_queue_id
		variable err_queue_time 

		if {[info exists laststamp(stamp,$id)]} {
			set timewait [expr {$laststamp(stamp,$id) + $pause - [unixtime]}]
			if {$timewait > 0} {return [subst -noc $err_queue_time]}			
		}
		if {[llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser} {return $err_queue_id}
		if {[llength [array names reqqueue]] >= $maxrequests} {return $err_queue_full}		
	return
	}

	proc queue_add {newurl id parser extra {redir 0}} {
		variable reqqueue
		variable proxy
		variable timeout
		variable laststamp
		variable query

		::http::config -proxyfilter "[namespace current]::queue_proxy"

		if {$query eq ""} {
			if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout]} errid]} {					
			set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
			} {return false}
		} {
			if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout -query ${query}]} errid]} {					
			set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
			} {return false}
		}
	return true
	}

	proc queue_proxy {url} {
		variable proxy

		if {$proxy ne {}} {return [split $proxy {:}]}		
		return [list]
	}
	
	proc queue_done {token} {
		upvar #0 $token state
		variable reqqueue
		variable maxredir
		variable fetchurl

		set errid  	[::http::status $token]
		set errstr 	[::http::error  $token]		
		set	id [array names reqqueue "$token,*"]
		foreach {parser extra redir} $reqqueue($id) {break}
		regsub -- "^$token," $id {} id
	
		while (1) {
			if {$errid == "ok" && [::http::ncode $token] == 302} {
				if {$redir < $maxredir} {			
					array set meta $state(meta)
					if {[info exists meta(Location)]} {queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir]; break}
				} {set errid "error" ; set errstr "Max. redir."}
			} 
			if {[catch {$parser {errid} {errstr} {state(body)} {extra}} errid]} {lput putlog $errid "[namespace current] "}
		break
		}			
		array unset reqqueue "$token,*"
		::http::cleanup $token
	return
	}

#--- 
	proc queue_clear_stamps {} {

		variable laststamp
		variable timeout
		variable timerID

		set curr [expr {[unixtime] - 2 * $timeout / 1000}];
		foreach {id} [array names laststamp] {if {$laststamp($id) < $curr} {array unset laststamp $id}}		
		set timerID [timer 10 "[info level 0]"]
	}

	proc cmdaliases {{action {bind}}} {
		foreach {bindtype} {pub msg dcc} {
			foreach {bindproc} [info vars "[namespace current]::${bindtype}:*"] {
				variable "${bindtype}prefix" ; variable "${bindtype}flag"			
				foreach {alias} [set $bindproc] {catch {$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc}}				
			}
		}	
	return
	}

#---init
	if {[info exists timerID]} {catch {killtimer $timerID} ; catch {unset timerID}}	
	[namespace current]::queue_clear_stamps
	[namespace current]::cmdaliases
#---log
  	variable sfil [lindex [split [info script] "/"] end]
  	variable modf [clock format [file mtime [info script]] -format "%d-%b-%Y : %H:%M:%S"]
	if {[info exists ::sp_version]} {putlog "[namespace current] v$version (suzi_$sp_version) :: file:$sfil / rel:\[$date\] / mod:\[$modf\] :: by $author :: loaded."} {putlog "[namespace current] v$version :: file:$sfil / rel:\[$date\] / mod:\[$modf\] :: by $author :: loaded."}

} ;#end










